// Generated by CoffeeScript 1.7.1
(function() {
  var Api,
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  Api = (function() {
    function Api(name, version) {
      this.name = name || 'api';
      this.version = parseInt(version) || 1;
      this.path = "/" + this.name + "/v" + this.version;
      this._resources = Array();
    }

    Api.prototype.register = function(resource) {
      if (__indexOf.call(this._resources, resource) < 0) {
        return this._resources.push(resource);
      }
    };

    Api.prototype.schema = function() {
      return require('./methods/schema')(this);
    };

    Api.prototype.make_routes = function(app, check_authentication) {
      var resource, _i, _len, _ref, _results;
      if (check_authentication != null) {
        app.all('*', check_authentication);
      }
      app.get("" + this.path, this.schema());
      _ref = this._resources;
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        resource = _ref[_i];
        if (resource.options.authorization.GET == null) {
          app.get("" + this.path + resource.collection_path + "/schema", resource.schema());
        } else {
          app.get("" + this.path + resource.collection_path + "/schema", resource.options.authorization.GET, resource.schema());
        }
        if (resource.options.authorization.GET == null) {
          app.get("" + this.path + resource.collection_path, resource.find());
        } else {
          app.get("" + this.path + resource.collection_path, resource.options.authorization.GET, resource.find());
        }
        if (resource.options.authorization.GET == null) {
          app.get("" + this.path + resource.document_path, resource.find_one());
        } else {
          app.get("" + this.path + resource.document_path, resource.options.authorization.GET, resource.find_one());
        }
        if (resource.options.authorization.POST == null) {
          app.post("" + this.path + resource.collection_path, resource.create());
        } else {
          app.post("" + this.path + resource.collection_path, resource.options.authorization.POST, resource.create());
        }
        if (resource.options.authorization.PUT == null) {
          app.put("" + this.path + resource.document_path, resource.update());
        } else {
          app.put("" + this.path + resource.document_path, resource.options.authorization.PUT, resource.update());
        }
        if (resource.options.authorization.DELETE == null) {
          _results.push(app["delete"]("" + this.path + resource.document_path, resource.destroy()));
        } else {
          _results.push(app["delete"]("" + this.path + resource.document_path, resource.options.authorization.DELETE, resource.destroy()));
        }
      }
      return _results;
    };

    return Api;

  })();

  module.exports = Api;

}).call(this);
