// Generated by CoffeeScript 1.7.1
(function() {
  var ref2resource, respond, self_uri, _;

  _ = require('lodash');

  ref2resource = require('./dry').ref2resource;

  self_uri = require('./dry').self_uri;

  respond = require('../../responses');

  module.exports = function(Resource) {
    return function(req, res) {
      var err, key, limit, query, skip, sort, value, where;
      limit = req.query.limit || Resource.options.limit;
      skip = req.query.skip || void 0;
      sort = req.query.sort || void 0;
      try {
        limit = parseInt(limit);
      } catch (_error) {
        err = _error;
        return respond.bad_request(res, err.message);
      }
      if (skip) {
        try {
          skip = parseInt(skip);
        } catch (_error) {
          err = _error;
          return respond.bad_request(res, err.message);
        }
      }
      query = _.merge(req.query, req.params);
      where = _.transform(query, function(conditions, value, key) {
        if (key !== 'limit' && key !== 'skip' && key !== 'sort') {
          return conditions[key] = value;
        }
      });
      for (key in where) {
        value = where[key];
        where[key] = JSON.parse(value);
      }
      return Resource.model.find(where).sort(sort).skip(skip).limit(limit).exec(function(err, models) {
        var body, model, _i, _len;
        if (err) {
          return respond.bad_request(res, err.errors);
        }
        for (_i = 0, _len = models.length; _i < _len; _i++) {
          model = models[_i];
          if (Resource.options.refs != null) {
            model._doc = ref2resource(model._doc, Resource.options.refs);
          }
          model._doc.resource_uri = self_uri(model._doc, Resource.collection_path);
        }
        body = {};
        body.meta = {};
        body.meta.page_size = limit;
        return Resource.model.count(where, function(err, count) {
          var new_skip, next, previous;
          if (err) {
            return respond.server_error(res, err);
          }
          body.meta.count = count;
          if (body.meta.count > limit && body.meta.count > skip + limit) {
            if (skip != null) {
              new_skip = skip + limit;
            } else {
              new_skip = limit;
            }
            next = "" + Resource.options.path + "?";
            if (sort) {
              next += "sort=" + sort + "&";
            }
            next += "skip=" + new_skip + "&limit=" + limit;
          } else {
            next = null;
          }
          body.meta.next = next;
          if ((skip != null) && skip !== 0) {
            if ((skip - limit) < 0) {
              new_skip = 0;
            } else {
              new_skip = skip - limit;
            }
            previous = "" + Resource.options.path + "?";
            if (sort) {
              previous += "sort=" + sort + "&";
            }
            previous += "skip=" + new_skip + "&limit=" + limit;
          } else {
            previous = null;
          }
          body.meta.previous = previous;
          body.objects = models;
          return respond.ok(res, body);
        });
      });
    };
  };

}).call(this);
