// Generated by CoffeeScript 1.7.1
(function() {
  var diff, ref2resource, respond;

  diff = require('deep-diff').diff;

  ref2resource = require('./dry').ref2resource;

  respond = require('../../responses');

  module.exports = function(Resource) {
    return function(req, res) {
      return Resource.model.findById(req.params._id, function(err, existing_model) {
        if (err) {
          return respond.server_error(res, err);
        }
        if (existing_model == null) {
          return respond.not_found(res, "`" + Resource.model.modelName + "`@`" + req.params._id + "` not found");
        }
        return Resource.model.findByIdAndUpdate(req.params._id, req.body, function(err, updated_model) {
          var delta;
          if (err) {
            return respond.not_acceptable(res, err.errors);
          }
          delta = diff(existing_model._doc, updated_model._doc);
          if (Resource.options.refs != null) {
            updated_model._doc = ref2resource(updated_model._doc, Resource.options.refs);
          }
          updated_model._doc.resource_uri = self_uri(updated_model._doc, Resource.collection_path);
          Resource.emitter.emit('updated', updated_model._id, JSON.stringify(delta));
          return respond.ok(res, updated_model);
        });
      });
    };
  };

}).call(this);
