// Generated by CoffeeScript 1.7.1
(function() {
  var EventEmitter, Resource, clean_path, _;

  _ = require('lodash');

  EventEmitter = require('events').EventEmitter;

  clean_path = function(path) {
    if (path.starts_with('/')) {
      path = path.pyslice(1);
    }
    if (path.ends_with('/')) {
      path = path.pyslice(0, -1);
    }
    path = path.toLowerCase();
    return path = path.replace(' ', '-');
  };

  Resource = (function() {
    function Resource(model, path, options) {
      this.model = model;
      this.options = {
        limit: 20,
        refs: {},
        authorization: {
          GET: null,
          POST: null,
          PUT: null,
          DELETE: null
        }
      };
      path = clean_path(path);
      this.collection_path = "/" + path;
      this.document_path = "" + this.collection_path + "/:_id";
      if (this.options != null) {
        _.merge(this.options, options);
      } else {
        this.options = default_options;
      }
      this.emitter = new EventEmitter();
    }

    Resource.prototype.find = function() {
      return require('./methods/find')(this);
    };

    Resource.prototype.find_one = function() {
      return require('./methods/find_one')(this);
    };

    Resource.prototype.create = function() {
      return require('./methods/create')(this);
    };

    Resource.prototype.update = function() {
      return require('./methods/update')(this);
    };

    Resource.prototype.destroy = function() {
      return require('./methods/destroy')(this);
    };

    Resource.prototype.schema = function() {
      return require('./methods/schema')(this);
    };

    return Resource;

  })();

  module.exports = Resource;

}).call(this);
