ref2resource = require('./dry').ref2resource
self_uri = require('./dry').self_uri

respond = require '../../responses'


module.exports = (Resource) ->
  (req, res) ->
    # create new instance
    model = new Resource.model(req.body)

    # use mongoose model method
    model.save (err) ->
      # payload validation failure -- model.schema.paths
      return respond.not_acceptable(res, err.errors) if err

      # sugar document
      model._doc = ref2resource(model._doc, Resource.options.refs) if Resource.options.refs?
      model._doc.resource_uri = self_uri(model._doc, Resource.collection_path)

      # emit event
      Resource.emitter.emit('created', model._id)

      # respond
      respond.created(res, model)
