respond = require '../../responses'


module.exports = (Resource) ->
  (req, res) ->
    # use mongoose model method to locate and remove
    Resource.model.findByIdAndRemove req.params._id, (err, model) ->
      # server error
      return respond.server_error(res, err) if err

      # 404
      return respond.not_found(res, "`#{Resource.model.modelName}`@`#{req.params._id}` not found") if !model?

      # emit even
      Resource.emitter.emit 'destroyed', model._doc

      # respond
      respond.no_content(res)
