is_array = Array.isArray or ( value ) -> return {}.toString.call( value ) is '[object Array]'


self_uri = (doc, path) ->
  "#{path}/#{doc._id}"


ref2resource = (doc, refs) ->
  # deep copy
  new_doc = JSON.parse(JSON.stringify doc)
  # iterate references
  for key, resource of refs
    # check for dot notation
    parts = key.split '.'

    # base case
    if parts.length == 1
      if is_array new_doc[key]
        new_new_doc = []
        for subdoc in new_doc[key]
          new_new_doc.push "#{resource.collection_path}/#{subdoc}"
        new_doc[key] = new_new_doc
      else
        new_doc[key] = "#{resource.collection_path}/#{new_doc[key]}"

    # drop into recursion
    else
      _key = parts[0]
      subdoc = new_doc[_key]
      new_key = parts.slice(1).join '.'
      new_refs = {}
      new_refs[new_key] = resource
      if is_array subdoc
        new_subdoc = []
        for el in subdoc
          val = ref2resource el, new_refs
          new_subdoc.push val
        new_doc[_key] = new_subdoc
      else
        new_doc[_key] = ref2resource subdoc, new_refs

  # return reauthored document
  new_doc


module.exports.is_array = is_array
module.exports.self_uri = self_uri
module.exports.ref2resource = ref2resource 
