ref2resource = require('./dry').ref2resource

respond = require '../../responses'


module.exports = (Resource) ->
  (req, res) ->
    # use mongoose model method to locate document
    Resource.model.findById req.params._id, (err, model) ->
      # internal error
      return respond.server_error(res, err) if err

      # 404
      return respond.not_found(res, "`#{Resource.model.modelName}`@`#{req.params._id}` not found") if !model?

      # sugar and respond
      model._doc = ref2resource(model._doc, Resource.options.refs) if Resource.options.refs?
      model._doc.resource_uri = self_uri(model._doc, Resource.collection_path)
      respond.ok(res, model)
