mongoose = require 'mongoose'
Schema = mongoose.Schema
ObjectId = Schema.Types.ObjectId

Resource = require('../../../lib').Resource


ftCliqueSchema = new Schema {
  name: { type: String, required: true }
  characteristics: [ String ]
}

ftClique = mongoose.model('ftClique', ftCliqueSchema)


ftPersonSchema = new Schema {
  name: {
    first: { type: String, required: true }
    last: { type: String, required: true }
    middle: String
    _id: false }
  birthday: Date
  email: { type: String, regex: /^\w{3,}@[a-zA-Z_\-]+?\.[a-zA-Z]{2,}$/ }
  cliques: [ { type: ObjectId, ref: ftClique } ]
}

ftPerson = mongoose.model('ftPerson', ftPersonSchema)


module.exports.Clique = ftClique
module.exports.Person = ftPerson
