describe 'Api', ->

  api = {}

  before ->
    Api = require('../../lib').Api
    api = new Api()
    mongoose = require 'mongoose'
    Resource = require('../../lib').Resource
    PersonSchema = new mongoose.Schema({name:String})
    Person = mongoose.model('Person', PersonSchema)
    resource = new Resource(Person, 'people')
    api.register(resource)

  it 'has a name property', (done) ->
    api.should.have.property 'name'
    done()

  it 'has a version property', (done) ->
    api.should.have.property 'version'
    done()

  it 'has a path property', (done) ->
    api.should.have.property 'path'
    done()

  describe 'Api.path', ->

    it 'should equal "/{api.name}/v{api.version}"', (done) ->
      api.path.should.equal '/api/v1'
      done()

  it 'has a (private) _resources property', (done) ->
    api.should.have.property '_resources'
    done()

  it 'has a schema method', (done) ->
    api.should.have.property 'schema'
    done()

  it 'has a make_routes method', (done) ->
    api.should.have.property 'make_routes'
    done()
