describe 'Resource', ->

  resource = {}

  before ->
    mongoose = require 'mongoose'
    Resource = require('../../lib').Resource
    PersonSchema = new mongoose.Schema({name:String})
    Person2 = mongoose.model('Person2', PersonSchema)
    resource = new Resource(Person2, 'people')

  it 'has a mongoose.model (model)', (done) ->
    resource.should.have.property 'model'
    done()

  it 'has an options dict', (done) ->
    resource.should.have.property 'options'
    done()

  describe 'Resource.options', ->

    it 'has a limit property', (done) ->
      resource.options.should.have.property 'limit'
      done()

    it 'has a refs property', (done) ->
      resource.options.should.have.property 'refs'
      done()

    it 'has an authorization property', (done) ->
      resource.options.should.have.property 'authorization'
      done()

    describe 'Resource.options.authorization', ->

      it 'has a GET property', (done) ->
        resource.options.authorization.should.have.property 'GET'
        done()

      it 'has a POST property', (done) ->
        resource.options.authorization.should.have.property 'POST'
        done()

      it 'has a PUT property', (done) ->
        resource.options.authorization.should.have.property 'PUT'
        done()

      it 'has a DELETE property', (done) ->
        resource.options.authorization.should.have.property 'DELETE'
        done()

  it 'has a collection_path property', (done) ->
    resource.should.have.property 'collection_path'
    done()

  it 'has a document_path property', (done) ->
    resource.should.have.property 'document_path'
    done()

  it 'has an event emitter object (emitter)', (done) ->
    resource.should.have.property 'emitter'
    done()

  it 'has a find method', (done) ->
    resource.should.have.property 'find'
    done()

  it 'has a find_one method', (done) ->
    resource.should.have.property 'find_one'
    done()

  it 'has a create method', (done) ->
    resource.should.have.property 'create'
    done()

  it 'has a update method', (done) ->
    resource.should.have.property 'update'
    done()

  it 'has a destroy method', (done) ->
    resource.should.have.property 'destroy'
    done()

  it 'has a schema method', (done) ->
    resource.should.have.property 'schema'
    done()
